// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/10/31 
//
//-------------------------------------------------------------------
//
// VideoFVC04WOIDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "VideoFVC04WOI.h"
#include "LicenceDlg.h"
#include "ConfFileDlg.h"
#include "VideoFVC04WOIDlg.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define TIMER_ID_GRAB 1		

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVideoFVC04WOIDlg _CAO

CVideoFVC04WOIDlg::CVideoFVC04WOIDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVideoFVC04WOIDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVideoFVC04WOIDlg)
	m_trigger = 0;
	m_exposure = 5;
	m_woimode = 0;
	m_setwoi = FALSE;
	m_ascope = FALSE;
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVideoFVC04WOIDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVideoFVC04WOIDlg)
	DDX_Control(pDX, IDC_LIST1, m_list);
	DDX_Control(pDX, IDC_SLDEXPOSURE, m_sldexposure);
	DDX_CBIndex(pDX, IDC_TRIGGER, m_trigger);
	DDX_Text(pDX, IDC_EXPOSURE, m_exposure);
	DDV_MinMaxInt(pDX, m_exposure, 1, 250);
	DDX_Radio(pDX, IDC_WOIMode1, m_woimode);
	DDX_Check(pDX, IDC_SETWOI, m_setwoi);
	DDX_Check(pDX, IDC_ASCOPE, m_ascope);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVideoFVC04WOIDlg, CDialog)
	//{{AFX_MSG_MAP(CVideoFVC04WOIDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SETWOI, OnSetwoi)
	ON_BN_CLICKED(IDC_WOIMode1, OnWOIMode1)
	ON_BN_CLICKED(IDC_WOIMode2, OnWOIMode2)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST1, OnItemchangedList1)
	ON_BN_CLICKED(IDC_GRAB, OnGrab)
	ON_BN_CLICKED(IDC_FREERUN, OnFreerun)
	ON_WM_TIMER()
	ON_CBN_SELCHANGE(IDC_TRIGGER, OnSelchangeTrigger)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_RESETVIDEOCONFFILE, OnResetvideoconffile)
	ON_BN_CLICKED(IDC_SAVEIMAGE, OnSaveimage)
	ON_BN_CLICKED(IDC_ASCOPE, OnAscope)
	ON_BN_CLICKED(IDC_DISPMINUS, OnDispminus)
	ON_BN_CLICKED(IDC_DISPPLUS, OnDispplus)
	ON_BN_CLICKED(IDC_DISP1, OnDisp1)
	ON_BN_CLICKED(IDC_DISPFULL, OnDispfull)
	ON_WM_DESTROY()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVideoFVC04WOIDlg bZ[W nh

BOOL CVideoFVC04WOIDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	// FvxSample 
	CLicenceDlg dlg;

	// CZXʂ̕\
	if (dlg.DoModal() == IDOK){

		//Ӂ
		// ߂COM̏sƂYȂłB
		CoInitialize(NULL);
		CWnd *pwnd ;
		IUnknown *p_unknown;
		long err_no = 0;

		// _CAOɓ\tĂFvxDisplayEx̃CX^X擾AX}[g|C^Ɋt܂B
		pwnd = GetDlgItem(IDC_FVXDISPLAYEX1);		// FvxDisplayEx̃nh擾
		p_unknown = pwnd->GetControlUnknown();		// Rg[̎IUnknownC^[tFCX擾
		p_unknown->QueryInterface(__uuidof(IFvxDisplayEx2Ptr),(void**)&m_FvxDisplayEx);

		// eFvxRg[̃CX^X𐶐܂B
		// w肷NXԈႦȂ悤ӂĂB
		m_FvxFileAccess.CreateInstance( __uuidof( FvxFileAccess ) ); 
		m_FvxImage.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxImageWOI.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxVideo.CreateInstance( __uuidof( FvxVideo ) ); 
		m_FvxPerformanceCounter.CreateInstance( __uuidof( FvxPerformanceCounter ) ); 
		
		// rfIfoCX̃I[vԕێϐ̏
		m_blnVideoOpened = false;
		GetDlgItem(IDC_GRAB)->EnableWindow(FALSE);
		GetDlgItem(IDC_FREERUN)->EnableWindow(FALSE);
		GetDlgItem(IDC_WOIMode1)->EnableWindow(FALSE);
		GetDlgItem(IDC_WOIMode2)->EnableWindow(FALSE);
		GetDlgItem(IDC_SETWOI)->EnableWindow(FALSE);
		GetDlgItem(IDC_LIST1)->EnableWindow(FALSE);

		// vectoȑ
		m_lngDispExWoiWndID.resize(MAX_WOI);
		m_lngDispExWoiNoID.resize(MAX_WOI);
		m_lngFlagChangeWoiWnd.resize(MAX_WOI);

		// XgRg[̏
		m_list.SetExtendedStyle(m_list.GetExtendedStyle() | LVS_EX_CHECKBOXES | LVS_EX_FULLROWSELECT);
		m_list.InsertColumn( 0, _T("No"), LVCFMT_LEFT, 40 );
		m_list.InsertColumn( 1, _T("xs"), LVCFMT_LEFT, 35 );
		m_list.InsertColumn( 2, _T("ys"), LVCFMT_LEFT, 35 );
		m_list.InsertColumn( 3, _T("xe"), LVCFMT_LEFT, 35 );
		m_list.InsertColumn( 4, _T("ye"), LVCFMT_LEFT, 35 );
		m_list.InsertColumn( 5, _T("Enable"), LVCFMT_LEFT, 55 );
		m_list.DeleteAllItems();

		// XC_[Rg[̏
		m_sldexposure.SetRange(1,250,FALSE);
		m_sldexposure.SetTicFreq(10);
		m_sldexposure.SetPos(m_exposure);

		// fBXvC̏
		m_FvxDisplayEx->CreateDisplay(2,0);

		// rfIfoCXI
		setVideoConfFile();

	}else{

		// ӂĂ炦Ȃ瑦I
		EndDialog( IDCANCEL );
	}

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CVideoFVC04WOIDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CVideoFVC04WOIDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CVideoFVC04WOIDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// rfIݒt@CI
void CVideoFVC04WOIDlg::setVideoConfFile()
{

    long lngCaptureType = 0;			// Lv`{[h̃^Cv(0=RICE/1=FVC01/2=FVC02)
    long lngCaptureNum = 0;				// Lv`{[h̖
    long lngCaptureConnectorNum = 0;	//P{[h̃RlN^
    long lngBinMode = 0;
	long err_no = 0;
	long i=0;

    VARIANT_BOOL bStatus ;
	CString str;

	CConfFileDlg fdlg;
    
    if ( m_blnVideoOpened ) {
        // rfIfoCXI[vĂꍇ͈UN[Y܂
        m_FvxVideo->CloseDevice();
        m_blnVideoOpened = false;
	}

	// rfIݒt@C̑I
	fdlg.DoModal();

	if (fdlg.m_conffile.GetLength() != 0) {
	
		
		// rfIݒt@CR|[lgɐݒ
 		m_FvxVideo->PutVideoConfFile( _bstr_t( fdlg.m_conffile ) );

		// rfIfoCXI[v
		try {

			m_FvxVideo->OpenDevice();

		} catch( _com_error ) {
		
			m_FvxVideo->GetErrReport( &err_no );
			MessageBox("rfIfoCX̃I[vɎs܂" , "G[" , MB_ICONWARNING | MB_OK );
			return;
		}

		// VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
		// ̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
		// {vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
		// g̃Lv`{[hɍ킹ĕύXĂB
		::Sleep(350);

		// GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
		// 炩ChangeImageSize\bhɂImagẽTCYύXĂ
		// i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
		m_FvxVideo->ChangeImageSize(m_FvxImage);

		try	{

			// 捞
			m_FvxVideo->GrabSync(m_FvxImage);

		} catch(_com_error ) {
		
			m_FvxVideo->GetErrReport( &err_no );
			MessageBox("rfI̎捞Ɏs܂" , "G[" , MB_ICONWARNING | MB_OK );
			return ;

		}

		// J荞ݗL
		GetDlgItem(IDC_GRAB)->EnableWindow(TRUE);
		GetDlgItem(IDC_FREERUN)->EnableWindow(TRUE);
		// rfIfoCX̏ԂL
		m_blnVideoOpened = true;

		// Lv`{[h擾
		m_FvxVideo->GetCaptureNum( &lngCaptureNum );

		// Lv`{[h^Cv擾
		m_FvxVideo->GetCaptureType( &lngCaptureType );
    
		// Rg[ނ̏
		CComboBox*    pcmb;

		// gK[h
		pcmb = ( CComboBox* )GetDlgItem( IDC_TRIGGER );
		pcmb->ResetContent();
		pcmb->AddString( "m[}" );
		pcmb->AddString( "gK(SW)" );

		// RICE(CaptureType=1)͊OgKgps
		if ( lngCaptureType >= 2 ) {                
			pcmb->AddString( "OgK(Ext)" );
		}
		m_trigger = 0 ;

		// I
		m_FvxVideo->GetExposureTime( &i );
		m_sldexposure.SetPos(  i / 1000 );
		m_exposure = (i / 1000);
       	GetDlgItem(IDC_SLDEXPOSURE)->EnableWindow(TRUE);
       	GetDlgItem(IDC_EXPOSURE)->EnableWindow(TRUE);
    
        // WOIgpł邩ǂmFAgpłGUI֘Ȁ
		CHAR strBuff[255];
		CString sString;

        GetPrivateProfileString("CameraInfo", "WoiUsable", "FALSE", strBuff, 256,  fdlg.m_conffile );
		sString = strBuff;
		sString.MakeUpper();

        if ( sString != "FALSE" ) {				// WOIgpłꍇ
            // WOI֘A
            bStatus = fnInitWoiWindow();
            GetDlgItem(IDC_WOIMode1)->EnableWindow(TRUE);
            GetDlgItem(IDC_WOIMode2)->EnableWindow(TRUE);
            GetDlgItem(IDC_SETWOI)->EnableWindow(TRUE);
			GetDlgItem(IDC_LIST1)->EnableWindow(TRUE);
		} else {                                // WOIgpłȂꍇ
            GetDlgItem(IDC_WOIMode1)->EnableWindow(FALSE);
            GetDlgItem(IDC_WOIMode2)->EnableWindow(FALSE);
            GetDlgItem(IDC_SETWOI)->EnableWindow(FALSE);
			GetDlgItem(IDC_LIST1)->EnableWindow(FALSE);
		}
	}
	
	GetDlgItem(IDC_LIST1)->EnableWindow(FALSE);
	m_trigger = 0 ;

	// 摜̕\
	m_FvxDisplayEx->DrawImage(m_FvxImage);

	UpdateData(FALSE);

}

// Lv`I[vALv`ɐݒ肳ĂWOIEBhE
// FvxDisplayExсAXgr[ɐݒ肷
bool CVideoFVC04WOIDlg::fnInitWoiWindow()
{

    IFvRectangle2Ptr pRect (__uuidof(FvRectangle));
    IFvPointPtr pPos (__uuidof(FvPoint));

	long i = 0;
	CString sFromat;
    CString strEnable;
    VARIANT_BOOL bEnable ;

    
    // FvxDisplayExɊւ鏉ݒ
    m_FvxDisplayEx->RoiSetFigureMax( DISPLAYEX_ROI_RECTANGLE, MAX_WOI );      // `ݒMAX_WOI(16)܂
    m_FvxDisplayEx->RoiChangeNewFigType( DISPLAYEX_ROI_RECTANGLE , FALSE );	  // }`쐬͋`̂
    m_FvxDisplayEx->PutRoiErasable( FALSE );								  // }`̍폜͂łȂ
    m_FvxDisplayEx->PutFontAlign( DISPLAYEX_FontTopLeft );                    // ̌_͍
    m_FvxDisplayEx->PutFontColor( RGB(255,0,0) );							  // F͐
	m_FvxDisplayEx->SetOverlayEnable( 1, FALSE );							  // I[oCPDisableɐݒ

    // WOI
    for ( i = 0 ; i < MAX_WOI ; i++ ) {

        // ݐݒ肳ĂWOIEBhE擾
        m_FvxVideo->GetWoiWindow( i, pRect );
        m_FvxVideo->GetWoiEnable( i, &bEnable );
        
        // `ݒ
        m_lngDispExWoiWndID[i] = m_FvxDisplayEx->RoiCreateFigure(pRect,TRUE);
        
        // EBhEԍݒ
        pPos->Putx( pRect->Getxs() + 5 );
        pPos->Puty( pRect->Getys() + 5 );
        
		sFromat.Format("%d",i);
		m_lngDispExWoiNoID[i] = m_FvxDisplayEx->DrawText(1, pPos, _bstr_t(sFromat));
        
        // Xgr[ɓo^
        if ( bEnable == TRUE ) {
            strEnable = "Enable";
        } else {
            strEnable = "Disable";
		}
		sFromat.Format("%d",i);
		m_list.InsertItem(i,sFromat);
		sFromat.Format("%0.f",pRect->Getxs());
		m_list.SetItemText(i,1,sFromat);
		sFromat.Format("%0.f",pRect->Getys());
		m_list.SetItemText(i,2,sFromat);
		sFromat.Format("%0.f",pRect->Getxe());
		m_list.SetItemText(i,3,sFromat);
		sFromat.Format("%0.f",pRect->Getye());
		m_list.SetItemText(i,4,sFromat);
		m_list.SetItemText(i,5,strEnable);

	}

	return true;
}

// WOIEBhEݒ
void CVideoFVC04WOIDlg::OnSetwoi() 
{
    
	UpdateData(TRUE);
	
	if ( m_setwoi == FALSE ) {
        
		// ݒ芮
        m_FvxDisplayEx->PutRoiMode(DISPLAYEX_ROIDisable);
        m_FvxDisplayEx->SetOverlayEnable( 1, FALSE );
        
		// WOIEBhE̐ݒ
        IFvRectangle2Ptr pRect (__uuidof(FvRectangle));

        // tO`FbNĕύX̂EBhÊ݂ݒ肷
        for ( int i = 0 ; i <  MAX_WOI ; i++ ){ 
			if ( 1 == m_lngFlagChangeWoiWnd[i] ) {
                m_FvxDisplayEx->RoiGetFigure( m_lngDispExWoiWndID[i], pRect );
                fnChangeWoiWindow( i, pRect );
			}
		}
			
        m_FvxVideo->ChangeImageSize( m_FvxImageWOI );
        
        // {^悤ɂ
        fnChangeButtonEnableWOI( TRUE );
	} else {
        
        // {^Ȃ悤ɂ
        fnChangeButtonEnableWOI( FALSE );
    
        m_FvxDisplayEx->DrawImage( m_FvxImage );
        m_FvxDisplayEx->PutRoiMode( DISPLAYEX_ROIEnable );
        m_FvxDisplayEx->SetOverlayEnable( 1, TRUE );
		m_lngFlagChangeWoiWnd.resize(MAX_WOI);

	}
	UpdateData(FALSE);
}

// WOIEBhE̕ύX
void CVideoFVC04WOIDlg::fnChangeWoiWindow(long lngWndNo, IFvRectangle2Ptr pRect)
{
    // JʐM
    fnCommCamera( TRUE );

	try	{

			// Xgr[̍XV
	CString sStr;
	sStr.Format("%0.f",pRect->Getxs());
	TRACE("\npRect->Getxs()= "+sStr);
	sStr.Format("%0.f",pRect->Getys());
	TRACE("\npRect->Getys()= "+sStr);
	sStr.Format("%0.f",pRect->Getxe());
	TRACE("\npRect->Getxe()= "+sStr);
	sStr.Format("%0.f",pRect->Getye());
	TRACE("\npRect->Getye()= "+sStr);


		//WOIEBhEݒ
		m_FvxVideo->SetWoiWindow( lngWndNo, pRect ,0x11);

	} catch(_com_error ) {
		long err_no = 0;	
		CString str;
		
		m_FvxVideo->GetErrReport( &err_no );
		str.Format("SetWoiWindow Error : %d  WndNo = %d",err_no, lngWndNo );
		MessageBox(str, "G[" , MB_ICONWARNING | MB_OK );
		return ;

	}
		
    //JʐM
    fnCommCamera( FALSE );

}

// WOIEBhEݒ蒆WOIEBhEݒ肪łȂ悤ɂ
void CVideoFVC04WOIDlg::fnChangeButtonEnableWOI( BOOL bEnable )
{
    GetDlgItem(IDC_GRAB)->EnableWindow(bEnable);
    GetDlgItem(IDC_FREERUN)->EnableWindow(bEnable);
    GetDlgItem(IDC_TRIGGER)->EnableWindow(bEnable);
	GetDlgItem(IDC_SLDEXPOSURE)->EnableWindow(bEnable);
	GetDlgItem(IDC_EXPOSURE)->EnableWindow(bEnable);
	GetDlgItem(IDC_WOIMode1)->EnableWindow(bEnable);
	GetDlgItem(IDC_WOIMode2)->EnableWindow(bEnable);
	GetDlgItem(IDC_RESETVIDEOCONFFILE)->EnableWindow(bEnable);
	GetDlgItem(IDC_SAVEIMAGE)->EnableWindow(bEnable);

	GetDlgItem(IDC_LIST1)->EnableWindow(!bEnable);
}

//uJʐMv\
void CVideoFVC04WOIDlg::fnCommCamera(BOOL bComm)
{
    if ( bComm ) {
		GetDlgItem(IDC_COMM)->SetWindowText("JʐM");
    } else {
		GetDlgItem(IDC_COMM)->SetWindowText("");
	}
}

void CVideoFVC04WOIDlg::OnWOIMode1() 
{
	fnWOIModeSet(0);
}

void CVideoFVC04WOIDlg::OnWOIMode2() 
{
	fnWOIModeSet(1);
}

void CVideoFVC04WOIDlg::fnWOIModeSet(int index)
{

    // JʐM
    fnCommCamera( TRUE );
    
    if ( 0 == index ) {
        m_FvxVideo->SetWoiMode( videoWoiNormal , 0 );    // m[}
        m_FvxVideo->ChangeImageSize( m_FvxImage );
    } else {
        m_FvxVideo->SetWoiMode( videoWoiChunk , 0 );     // `N
        m_FvxVideo->ChangeImageSize( m_FvxImageWOI );
	}
		
    // JʐM
    fnCommCamera( FALSE );

}

// WOIEBhEEnable̕ύX
CVideoFVC04WOIDlg::fnChangeWoiWindowEnable(long lngWndNo, BOOL bEnable)
{

	// JʐM
    fnCommCamera( TRUE );
    
    // WOIEBhEEnableݒ
    m_FvxVideo->SetWoiEnable( lngWndNo, bEnable ,0x01);
    
    // JʐM
    fnCommCamera( FALSE );

}

// Xgr[̃`FbN{bNX
void CVideoFVC04WOIDlg::OnItemchangedList1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;

	if(pNMListView->uChanged & LVIF_STATE&& (pNMListView->uNewState ^ pNMListView->uOldState) & LVIS_STATEIMAGEMASK)
	{

		UpdateData(TRUE);
		
		if ( m_setwoi == TRUE ) {
			
			if(((CListCtrl *)GetDlgItem(IDC_LIST1))->GetCheck(pNMListView->iItem)) {
				m_list.SetItemText(pNMListView->iItem,5,"Enable");
				//WOIEBhEEnable̐ݒ
				fnChangeWoiWindowEnable(pNMListView->iItem, TRUE );
            
			} else {
				m_list.SetItemText(pNMListView->iItem,5,"Disable");
				// WOIEBhEEnable̐ݒ
				fnChangeWoiWindowEnable(pNMListView->iItem, FALSE );
			}    
		}
	}

	// Xgr[̃ACeNbN
	if ( m_setwoi == TRUE ) {
		m_FvxDisplayEx->RoiChangeActiveFigure(m_lngDispExWoiWndID[pNMListView->iItem],TRUE );
	}

	UpdateData( FALSE );
	*pResult = 0;
}


BEGIN_EVENTSINK_MAP(CVideoFVC04WOIDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CVideoFVC04WOIDlg)
	ON_EVENT(CVideoFVC04WOIDlg, IDC_FVXDISPLAYEX1, 12 /* RoiMouseMove */, OnRoiMouseMoveFvxdisplayex1, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4)
	ON_EVENT(CVideoFVC04WOIDlg, IDC_FVXDISPLAYEX1, 11 /* RoiMouseUp */, OnRoiMouseUpFvxdisplayex1, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

// ROI}`̈ړ
void CVideoFVC04WOIDlg::OnRoiMouseMoveFvxdisplayex1(long X, long Y, long nCtrl, long nFigID, long nFigType) 
{
    IFvPointPtr pPos (__uuidof(FvPoint));
    IFvRectangle2Ptr pRect (__uuidof(FvRectangle));
    CString sStr;

	UpdateData(TRUE);

    // }`IDWOI WindowԍZo
    long nNo = fnGetWndIDtoNO(nFigID);
    
    // }`̈ʒuZo
    m_FvxDisplayEx->RoiGetFigure( nFigID, pRect );

    // }`ԍ̈ʒuړ
    pPos->Putx( pRect->Getxs() + 5 );
    pPos->Puty( pRect->Getys() + 5 );
    sStr.Format("%d",nNo);
	m_FvxDisplayEx->UpdateText( m_lngDispExWoiNoID[nNo], pPos, _bstr_t( sStr ) );
    
    // Xgr[̍XV
	sStr.Format("%0.f",pRect->Getxs());
	m_list.SetItemText(nNo,1,sStr);
	sStr.Format("%0.f",pRect->Getys());
	m_list.SetItemText(nNo,2,sStr);
	sStr.Format("%0.f",pRect->Getxe());
	m_list.SetItemText(nNo,3,sStr);
	sStr.Format("%0.f",pRect->Getye());
	m_list.SetItemText(nNo,4,sStr);

	UpdateData(FALSE);

}

// FvxDisplayEx1̐}`IDAEBhEԍ擾
long CVideoFVC04WOIDlg::fnGetWndIDtoNO(long lngID)
{
    long i = 0;

    for ( i = 0 ; i < MAX_WOI ; i++ ){
		if (m_lngDispExWoiWndID[i] == lngID ) {
            break;
		}
	}
	return i;
}

// ROI}`̈ړi}EXAbvj
void CVideoFVC04WOIDlg::OnRoiMouseUpFvxdisplayex1(long X, long Y, long nCtrl, long nFigID, long nFigType) 
{
    IFvPointPtr pPos (__uuidof(FvPoint));
    IFvRectangle2Ptr pRect (__uuidof(FvRectangle));
    CString sStr;

	UpdateData(TRUE);

    // }`IDWOI WindowԍZo
    long nNo = fnGetWndIDtoNO(nFigID);
    
    // }`̈ʒuZo
    m_FvxDisplayEx->RoiGetFigure( nFigID, pRect );
    
    // }`̈ʒuATCYWOIݒ̐ɈvȂꍇ邽߁AŏC
	sStr.Format("%0.f",pRect->Getxs());
	sStr.Format("%0.f",pRect->Getys());
	sStr.Format("%0.f",pRect->Getxe());
	sStr.Format("%0.f",pRect->Getye());
    
	fnCorrectWindowSize( pRect );
    m_FvxDisplayEx->RoiUpdateFigure( nFigID, pRect );

    // }`ԍ̈ʒuړ
    pPos->Putx( pRect->Getxs() + 5 );
    pPos->Puty( pRect->Getys() + 5 );
    sStr.Format("%d",nNo);
	m_FvxDisplayEx->UpdateText( m_lngDispExWoiNoID[nNo], pPos, _bstr_t( sStr ) );
    
    // Xgr[̍XV
	sStr.Format("%0.f",pRect->Getxs());
	m_list.SetItemText(nNo,1,sStr);
	sStr.Format("%0.f",pRect->Getys());
	m_list.SetItemText(nNo,2,sStr);
	sStr.Format("%0.f",pRect->Getxe());
	m_list.SetItemText(nNo,3,sStr);
	sStr.Format("%0.f",pRect->Getye());
	m_list.SetItemText(nNo,4,sStr);
    
    // WOIEBhEʒuύXꂽƂtOɎc
    m_lngFlagChangeWoiWnd[nNo] = 1;

	UpdateData(FALSE);

}

// WOĨEBhETCYɈȂ悤ɁA`̈ʒuC
void CVideoFVC04WOIDlg::fnCorrectWindowSize(IFvRectangle2Ptr pDst)
{
    
	double dTmp = 0;

    // 召֌W
    if ( pDst->Getxs() > pDst->Getxe() ) {
        dTmp = pDst->Getxs();
        pDst->Putxs( pDst->Getxe() );
        pDst->Putxe( dTmp );
	}
	if ( pDst->Getys() > pDst->Getye() ) {
        dTmp = pDst->Getys();
        pDst->Putys( pDst->Getye());
        pDst->Putye( dTmp );
	}

    // Xn_ 32̔{
	pDst->Putxs((int)((pDst->Getxs() / 32)+0.5) * 32 );
	// Yn_ 2̔{
    pDst->Putys((int)((pDst->Getys() / 2)+0.5) * 2 );
    
    // TCY 64ȏ32̔{
    if ((pDst->Getxe() - pDst->Getxs() + 1) < 64 ) {
        pDst->Putxe( pDst->Getxs() + 64 - 1 );
    } else {
        pDst->Putxe((int)((pDst->Getxe() / 32)+0.5) * 32 - 1 );
	}
			
    // cTCY 2̔{
    pDst->Putye((int)((pDst->Getye() / 2)+0.5) * 2 - 1 );
}

// J荞
void CVideoFVC04WOIDlg::OnGrab() 
{
    double dblTime = 0;
	CString str;
    
	UpdateData(TRUE);

    // ԑJn
	m_FvxPerformanceCounter->StartCount();
    
	try {

		// 捞
		if ( m_woimode == 0 ) {
			m_FvxVideo->GrabSync( m_FvxImage );
		} else {
			m_FvxVideo->GrabSync( m_FvxImageWOI );
		}
	} catch (_com_error) {

	    long lngErr = 0;
		m_FvxVideo->GetErrReport( &lngErr );
		
		str.Format("捞G[ ( %d,)",lngErr);
		if (lngErr != 0) {
			MessageBox(str, "G[" , MB_ICONWARNING | MB_OK );
		}
	}

	//ԑI
	m_FvxPerformanceCounter->StopCount( &dblTime );    
    
	// 荞񂾉摜ʂɕ\
	if ( m_woimode == 0 ) {
		m_FvxDisplayEx->DrawImage( m_FvxImage );
	} else {
		m_FvxDisplayEx->DrawImage( m_FvxImageWOI );
	}
    str.Format("%.2fms",dblTime);
	GetDlgItem(IDC_GRABTIME)->SetWindowText( str );
	
}

// t[JnE~
void CVideoFVC04WOIDlg::OnFreerun() 
{
    if ( m_intIsFreerun == 1 ) {
		GetDlgItem( IDC_GRAB )->EnableWindow(TRUE);
		GetDlgItem(IDC_FREERUN)->SetWindowText("Freerun");
		KillTimer( TIMER_ID_GRAB );
		m_intIsFreerun = 0;
	} else {
		SetTimer( TIMER_ID_GRAB, 50, NULL );
		GetDlgItem( IDC_GRAB )->EnableWindow(FALSE);
		GetDlgItem(IDC_FREERUN)->SetWindowText("Stop");
		m_intIsFreerun = 1;
	}

}

void CVideoFVC04WOIDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	UpdateData(TRUE);
	
	switch( nIDEvent ){
		case TIMER_ID_GRAB:

			if ( m_blnVideoOpened ) {

				try {
					// ԑJn
					m_FvxPerformanceCounter->StartCount();   

					// 捞
					if ( m_woimode == 0 ) {
						m_FvxVideo->GrabSync( m_FvxImage );
					} else {
						m_FvxVideo->GrabSync( m_FvxImageWOI );
					}
					
					// ԑI
					double dblTime = 0;
					m_FvxPerformanceCounter->StopCount( &dblTime );
					// 摜\
					if ( m_woimode == 0 ) {
						m_FvxDisplayEx->DrawImage( m_FvxImage );
					} else {
						m_FvxDisplayEx->DrawImage( m_FvxImageWOI );
					}
					CString szTmp;
					szTmp.Format("%.2fms",dblTime);
					GetDlgItem(IDC_GRABTIME)->SetWindowText(szTmp);
				} catch( _com_error ) {
					long err_no=0;
					CString szErr;
					m_FvxVideo->GetErrReport( &err_no );
					szErr.Format("捞G[( %d )",err_no);
					MessageBox(szErr, "G[" , MB_ICONWARNING | MB_OK );
					KillTimer( TIMER_ID_GRAB );
					m_intIsFreerun = 0;
					return;
				}

			}
	}
	
	CDialog::OnTimer(nIDEvent);
}

// gK[h
void CVideoFVC04WOIDlg::OnSelchangeTrigger() 
{
    if (!UpdateData(TRUE)) return;
    if ( m_blnVideoOpened ) {
		try {
	        m_FvxVideo->SetTrigger( m_trigger );

		} catch ( _com_error) {
	        
			long lngErr = 0;
			CString cStr;

			m_FvxVideo->GetErrReport(&lngErr);
			cStr.Format("gK[[h̕ύX͂ł܂ł %d",lngErr);
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);

		}
	}	
	
}

BOOL CVideoFVC04WOIDlg::PreTranslateMessage(MSG* pMsg) 
{
	if(pMsg->message == WM_KEYDOWN)
	{
		switch( pMsg->wParam )
		{
			case VK_RETURN:
			case VK_ESCAPE:
				return false;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CVideoFVC04WOIDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CString str;

    if(pScrollBar == (CScrollBar*)&m_sldexposure){
		str.Format("%d",m_sldexposure.GetPos());
		GetDlgItem(IDC_EXPOSURE)->SetWindowText(str);
		if ( m_blnVideoOpened ) {
			m_FvxVideo->SetExposureTime( m_sldexposure.GetPos()* 1000);
		}
    }
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

// rfIݒt@CĐݒ
void CVideoFVC04WOIDlg::OnResetvideoconffile() 
{
	// t[Ȃ΁A~B
    if ( m_intIsFreerun == 1 ) {
		GetDlgItem( IDC_GRAB )->EnableWindow(TRUE);
		GetDlgItem(IDC_FREERUN)->SetWindowText("Freerun");
		KillTimer( TIMER_ID_GRAB );
		m_intIsFreerun = 0;
	}
    
    // rfIfoCX̑I
    setVideoConfFile();
	
}

// \摜ۑ
void CVideoFVC04WOIDlg::OnSaveimage() 
{
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		m_FvxFileAccess->PutFilePath ( _bstr_t( cFileDlg.GetPathName() ));

		try {
		
		if ( m_woimode == 0 ) {
			m_FvxFileAccess->SaveBitmap( m_FvxImage );
		} else {
			m_FvxFileAccess->SaveBitmap( m_FvxImageWOI );
		}
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
	
}

// AScope\؂ւ
void CVideoFVC04WOIDlg::OnAscope() 
{
	if ( !UpdateData(TRUE) ) return;

	if (m_ascope) {
		m_FvxDisplayEx->PutAScopeMode( DISPLAYEX_AScopeAuto );
	} else {
		m_FvxDisplayEx->PutAScopeMode( DISPLAYEX_AScopeDisable );
	}
}

// \{minus
void CVideoFVC04WOIDlg::OnDispminus() 
{
	m_FvxDisplayEx->PutMagnification( m_FvxDisplayEx->GetMagnification() - 0.5 );
    if ( m_FvxDisplayEx->GetMagnification()  <= 0.5   ) {
		GetDlgItem(IDC_DISPMINUS)->EnableWindow( FALSE );
    } else {
		GetDlgItem(IDC_DISPMINUS)->EnableWindow( TRUE );
	}
	GetDlgItem(IDC_DISPPLUS)->EnableWindow( TRUE );	
}

// \{plus
void CVideoFVC04WOIDlg::OnDispplus() 
{
	m_FvxDisplayEx->PutMagnification( m_FvxDisplayEx->GetMagnification() + 0.5 );
    if ( m_FvxDisplayEx->GetMagnification() > 10) {
		GetDlgItem(IDC_DISPPLUS)->EnableWindow( FALSE );	
    } else {
		GetDlgItem(IDC_DISPPLUS)->EnableWindow( TRUE );	
	}
	GetDlgItem(IDC_DISPMINUS)->EnableWindow( TRUE );
	
}

// {\
void CVideoFVC04WOIDlg::OnDisp1() 
{
    m_FvxDisplayEx->PutMagnification( 1 );
    
	GetDlgItem(IDC_DISPPLUS)->EnableWindow( TRUE );
	GetDlgItem(IDC_DISPMINUS)->EnableWindow( TRUE );	
}

// tʕ\
void CVideoFVC04WOIDlg::OnDispfull() 
{
	CRect rect;

	GetDlgItem( IDC_FVXDISPLAYEX1 )->GetWindowRect( rect );

	// XN[WNCAgWɕϊ
	ScreenToClient( rect );

    double dblScaleX = ( (double)( rect.right - rect.left )) / m_FvxImage->GetImageWidth();
    double dblScaleY = ( (double)( rect.bottom - rect.top )) / m_FvxImage->GetImageHeight();
   

	if ( dblScaleX < dblScaleY ) {
        m_FvxDisplayEx->PutMagnification( dblScaleX );
    } else {
        m_FvxDisplayEx->PutMagnification( dblScaleY );
	}
			
	GetDlgItem(IDC_DISPPLUS)->EnableWindow( TRUE );
	GetDlgItem(IDC_DISPMINUS)->EnableWindow( TRUE );	
	
}

void CVideoFVC04WOIDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
    // rfIfoCXI[vĂꍇ̓N[Y܂
	if ( m_blnVideoOpened == true ) {
		m_FvxVideo->CloseDevice();	
	}
}

void CVideoFVC04WOIDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	if (IsIconic() == 0 ) {

		if ( m_FvxDisplayEx != NULL ){

			CWnd *pwnd;
			CRect rect;

			pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
			pwnd->GetWindowRect( rect );

			// XN[WNCAgWɕϊ
			ScreenToClient( rect );

			// FvxDisplayEx̃TCYύX
			pwnd->MoveWindow( rect.left , rect.top, cx - (rect.left + 20) , cy - (rect.top + 20) , TRUE );

		}
	}
	
}
